/** @module project/state */

/**
 * state.js
 *
 * Collection of everything which has to do with state changes.
 * - actionTypes
 * - actions
 **/

import combineReducers from 'redux'
import reduxCrudGen from 'redux-gen/crud'
import reduxBasicGen from 'redux-gen/basic'
import { NAME, DATA } from './constants'
// import { call, put, takeEvery } from 'redux-saga/effects'

const basic = reduxBasicGen()
const crud = reduxCrudGen()

/** actionTypes define what actions are handeled by the reducer. */
const actions = { ...basic.actions, ...crud.actions }
console.log('State actions', actions)

/** state definition */
/** It is generally easier to not have another object here. */
export const state = [ ...basic.state, ...crud.state ]
console.log('State state', state)

/** reducer is called by the redux dispatcher and handles all component actions */
export const reducer = combineReducers(basic.reducer, crud.reducer)

/** sagas are asynchronous workers (JS generators) to handle the state. */
export const workers = crud.workers

// Watcher (intercepts INCREMENT_REQUEST, dispatches INCREMENT_SUCCESS or INCREMENT_FAIL in return.)
export const watchers = crud.watchers
